<?php

// ##########################################################################
// #                         Text to Image                                  #
// ##########################################################################
// # By: Darin Gilchrist                                                    #
// #     01/04/2009                                                         #
// #                                                                        #
// # This software is FREEWARE but not to be sold, re-packaged, or modified #
// # for commercial use without permission from the creator.                #
// ##########################################################################
// # Requirements:                                                          #
// # - PHP 5 minimum. (Not tested on other versions)                        #
// # - GD 2.0.                                                              #
// ##########################################################################

$font = 'fonts/Humanist 521 BT.ttf';		// SET FONT HERE

// GET INFORMATION OR USE DEFAULTS
$text = urldecode($_GET['text'])	OR $text	= "(missing text)";
$angle = $_GET['angle']				OR $angle	= 0;
$fgcolor = $_GET['fgcolor']			OR $fgcolor = "000000";
$bgcolor = $_GET['bgcolor']			OR $bgcolor = "FFFFFF";
$size = $_GET['size']				OR $size	= 12;

// GET BOUNDS OF TEXT
$bounds = imagettfbbox($size, $angle, $font, $text );
$min_x = min($bounds[0], $bounds[2], $bounds[4], $bounds[6]);
$min_y = min($bounds[1], $bounds[3], $bounds[5], $bounds[7]);
$max_x = max($bounds[0], $bounds[2], $bounds[4], $bounds[6]);
$max_y = max($bounds[1], $bounds[3], $bounds[5], $bounds[7]);
$img_width  = $max_x-$min_x;
$img_height = $max_y-$min_y;

// CREATE IMAGE SPACE
$im = imagecreatetruecolor($img_width, $img_height);

// FILL IN BACKGROUND COLOR
$bgcolor = get_rgb($im, $bgcolor);
imagefilledrectangle($im, 0, 0, $img_width, $img_height, $bgcolor);

// WRITE TEXT OVER BACKGROUND
$fgcolor = get_rgb($im, $fgcolor);
imagettftext($im, $size, $angle, abs($min_x), abs($min_y), $fgcolor, $font, $text);

// OUTPUT
header("Content-type: image/jpeg");
imagejpeg($im, NULL, 70);
imagedestroy($im);

function get_rgb($im, $color)
{
	$color = trim($color, "\#");
	$r = hexdec(substr($color, 0, 2));
	$g = hexdec(substr($color, 2, 2));
	$b = hexdec(substr($color, 4, 2));
	return imagecolorallocate($im, $r, $g, $b);
}

?>